﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Layers;
using System.Diagnostics;
using Infragistics.UltraChart.Core.Primitives;

namespace CompositeChart
{
    public partial class Form1 : Form
    {
        private DataTable dt;
        private ScatterChartAppearance sca1;
        private ScatterChartAppearance sca2;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            this.ultraChart1.ChartType = ChartType.Composite;

            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);

            dt = new DataTable();
            dt.Columns.Add("Month", typeof(DateTime));
            dt.Columns.Add("MonthLab", typeof(string));
            dt.Columns.Add("2010", typeof(double));
            dt.Columns.Add("2011", typeof(double));
            dt.Columns.Add("2012", typeof(double));

            dt.Rows.Add(DateTime.Today, "Jul", 10, 50, 30);
            dt.Rows.Add(DateTime.Today.AddMonths(1), "Aug", 20, 35, 15);
            dt.Rows.Add(DateTime.Today.AddMonths(2), "Sep", 40, 60, 25);
            dt.Rows.Add(DateTime.Today.AddMonths(3), "Oct", 15, 40, 30);
            dt.Rows.Add(DateTime.Today.AddMonths(4), "Nov", 20, 35, null);
            dt.Rows.Add(DateTime.Today.AddMonths(5), "Dec", 20, 25, null);
            dt.Rows.Add(DateTime.Today.AddMonths(6), "Jan", 10, 50, null);
            dt.Rows.Add(DateTime.Today.AddMonths(7), "Feb", 20, 35, null);
            dt.Rows.Add(DateTime.Today.AddMonths(8), "Mar", 15, 40, null);
            dt.Rows.Add(DateTime.Today.AddMonths(9), "Apr", 40, 60, null);
            dt.Rows.Add(DateTime.Today.AddMonths(10), "May", 20, 35, null);
            dt.Rows.Add(DateTime.Today.AddMonths(11), "Jun", 20, 25, null);


            AxisItem axisX = new AxisItem();
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.Extent = 120;
            axisX.DataType = AxisDataType.Time;
            axisX.NumericAxisType = NumericAxisType.Linear;
            axisX.LineColor = Color.Blue;
            //axisX.ScrollScale.Visible = true;

            axisX.Labels.Visible = true;
            axisX.Labels.Orientation = TextOrientation.VerticalLeftFacing;
            axisX.Labels.ItemFormat = AxisItemLabelFormat.ItemLabel;
            axisX.TickmarkInterval = 1;
            axisX.SetLabelAxisType = SetLabelAxisType.DateData;
            //axisX.RangeType = AxisRangeType.Custom;
            //axisX.RangeMin = 0;
            //axisX.RangeMax = 12;

            area.Axes.Add(axisX);

            AxisItem axisY = new AxisItem();
            axisY.Extent = 20;
            axisY.DataType = AxisDataType.Numeric;
            axisY.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axisY.OrientationType = AxisNumber.Y_Axis;
            axisY.LineColor = Color.Blue;
            area.Axes.Add(axisY);


            NumericTimeSeries series1 = new NumericTimeSeries();
            series1.Label = "Year 2010";
            series1.DataBind(dt, "Month", "2010", "2010");
            series1.PEs.Add(new PaintElement(Color.Blue));

            NumericTimeSeries series2 = new NumericTimeSeries();
            series2.Label = "Year 2011";
            series2.DataBind(dt, "Month", "2011", "MonthLab");
            series2.PEs.Add(new PaintElement(Color.Red));


            NumericTimeSeries series3 = new NumericTimeSeries();
            series3.Label = "Year 2012";
            series3.DataBind(dt, "Month", "2012", "MonthLab");
            series3.PEs.Add(new PaintElement(Color.Yellow));



            ChartLayerAppearance myColumnLayer = new ChartLayerAppearance();
            myColumnLayer.ChartType = ChartType.ScatterChart;
            myColumnLayer.ChartArea = area;
            myColumnLayer.Series.Add(series1);
            myColumnLayer.AxisX = axisX;
            myColumnLayer.AxisY = axisY;
            ultraChart1.CompositeChart.Series.Add(series1);
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer);



            ChartLayerAppearance myColumnLayer2 = new ChartLayerAppearance();
            myColumnLayer2.ChartType = ChartType.ScatterChart;
            myColumnLayer2.ChartArea = area;
            myColumnLayer2.AxisX = axisX;
            myColumnLayer2.AxisY = axisY;
            myColumnLayer2.Series.Add(series2);
            ultraChart1.CompositeChart.Series.Add(series2);
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer2);

            ChartLayerAppearance myColumnLayer3 = new ChartLayerAppearance();
            myColumnLayer3.ChartType = ChartType.ScatterChart;
            myColumnLayer3.ChartArea = area;
            myColumnLayer3.AxisX = axisX;
            myColumnLayer3.AxisY = axisY;
            myColumnLayer3.Series.Add(series3);
            ultraChart1.CompositeChart.Series.Add(series3);
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer3);



            sca1 = new ScatterChartAppearance();
            sca1.ConnectWithLines = true;
            sca1.Icon = SymbolIcon.Circle;
            sca1.IconSize = SymbolIconSize.Medium;// Large;// Small;
            myColumnLayer.ChartTypeAppearance = sca1;


            sca2 = new ScatterChartAppearance();
            sca2.ConnectWithLines = true;
            sca2.Icon = SymbolIcon.Triangle;
            sca2.IconSize = SymbolIconSize.Medium;// Large;// Small;
            myColumnLayer2.ChartTypeAppearance = sca2;
            myColumnLayer3.ChartTypeAppearance = sca2;

            ultraComboEditor1.Items.Add(SymbolIcon.Circle);
            ultraComboEditor1.Items.Add(SymbolIcon.Diamond);
            ultraComboEditor1.Items.Add(SymbolIcon.Plus);
            ultraComboEditor1.Items.Add(SymbolIcon.Square);
            ultraComboEditor1.Items.Add(SymbolIcon.Triangle);
            ultraComboEditor1.Value = SymbolIcon.Circle;

            ultraComboEditor2.Items.Add(SymbolIcon.Circle);
            ultraComboEditor2.Items.Add(SymbolIcon.Diamond);
            ultraComboEditor2.Items.Add(SymbolIcon.Plus);
            ultraComboEditor2.Items.Add(SymbolIcon.Square);
            ultraComboEditor2.Items.Add(SymbolIcon.Triangle);
            ultraComboEditor2.Value = SymbolIcon.Triangle;

            CompositeLegend myLegend = new CompositeLegend();
            myLegend.ChartLayers.Add(myColumnLayer);
            myLegend.ChartLayers.Add(myColumnLayer2);
            myLegend.ChartLayers.Add(myColumnLayer3);
            myLegend.ChartLayers[1].LegendItem = LegendItemType.Auto;
            myLegend.Bounds = new Rectangle(6, 2, 15, 12);
            myLegend.BoundsMeasureType = MeasureType.Percentage;
            myLegend.PE.ElementType = PaintElementType.Gradient;
            myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal;
            myLegend.PE.Fill = Color.CornflowerBlue;
            myLegend.PE.FillStopColor = Color.Transparent;
            myLegend.Border.CornerRadius = 10;
            myLegend.Border.Thickness = 1;

            this.ultraChart1.CompositeChart.Legends.Add(myLegend);

            ultraChart1.DataItemOver += new Infragistics.UltraChart.Shared.Events.DataItemOverEventHandler(ultraChart1_DataItemOver);


            BoxAnnotation ba = new BoxAnnotation();
            ba.Text = "Test 1";
            ba.Location.Type = LocationType.Pixels;
            ba.FillColor = Color.Yellow;
            ba.Visible = true;
            ba.Border.CornerRadius = 10;
            ba.Width = 50;
            ba.Location.LocationX = 340;
            ba.Location.LocationY = 140;
            ultraChart1.Annotations.Annotations. Add(ba);

            BoxAnnotation ba1 = new BoxAnnotation();
            ba1.Text = "Test 2";
            ba1.Location.Type = LocationType.Pixels;
            ba1.Location.Row = 4;
            ba1.FillColor = Color.Red;
            ba1.Visible = true;
            ba1.Border.CornerRadius = 10;
            ba1.Width = 50;
            ba1.Location.LocationX = 240;
            ba1.Location.LocationY = 240;
            ultraChart1.Annotations.Annotations.Add(ba1);
        }

        void ultraChart1_DataItemOver(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {

        }

        private void ultraButton3_Click(object sender, EventArgs e)
        {
            ultraChart1.SaveTo(@"..\\..\\Test.bmp", System.Drawing.Imaging.ImageFormat.Bmp);
            Process.Start("..\\..\\Test.bmp");
        }

        private void ultraComboEditor1_ValueChanged(object sender, EventArgs e)
        {
            sca1.Icon = (SymbolIcon)ultraComboEditor1.Value;
        }

        private void ultraComboEditor2_ValueChanged(object sender, EventArgs e)
        {
            sca2.Icon = (SymbolIcon)ultraComboEditor2.Value;
        }

        private void ultraChart1_ChartDrawItem(object sender, Infragistics.UltraChart.Shared.Events.ChartDrawItemEventArgs e)
        {

        }

        private void ultraChart1_DataItemOver_1(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {

        }

        private void ultraChart1_MouseClick(object sender, MouseEventArgs e)
        {
            //foreach (Annotation ann in ultraChart1.Annotations.Annotations)
            //{
            //    if (ann.GetType() == typeof(BoxAnnotation) && ((BoxAnnotation)ann).Location.LocationX <= e.Location.X && ((BoxAnnotation)ann).Location.LocationX + ((BoxAnnotation)ann).Width >= e.Location.X)
            //    {
            //        MessageBox.Show("Annotation: " + ((BoxAnnotation)ann).Text);
            //        Debug.WriteLine("Annotation: " + ((BoxAnnotation)ann).Text);
            //    }
            //}
        }


    }
}